--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows Tailoring Reagents.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TITAN_RESTAILM"
local shaldorei = 0
local startShaldorei = 0

local silkweave = 0
local startSilkweave = 0
-----------------------------------------------
local function getShaldorei()
	return GetItemCount(124437, true) or 0
end
-----------------------------------------------
local function getSilkweave()
	return GetItemCount(127004, true) or 0
end
-----------------------------------------------
local function GetButtonText(self, id)
	local shaldoreiText
	if not shaldorei then
		shaldoreiText = "  |TInterface\\Icons\\inv_tailoring_70_silkweave:0|t "..TitanUtils_GetHighlightText("0")
	else
		shaldoreiText = "  |TInterface\\Icons\\inv_tailoring_70_silkweave:0|t "..TitanUtils_GetHighlightText(shaldorei)
	end

	local silkweaveText
	if not silkweave then
		silkweaveText = "  |TInterface\\Icons\\inv_tailoring_70_silkweaveimbued:0|t "..TitanUtils_GetHighlightText("0")
	else
		silkweaveText = "  |TInterface\\Icons\\inv_tailoring_70_silkweaveimbued:0|t "..TitanUtils_GetHighlightText(silkweave)
	end

	local barBalanceShaldorei = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (shaldorei - startShaldorei) > 0 then
			barBalanceShaldorei = " |cFF69FF69["..(shaldorei - startShaldorei).."]"
		elseif (shaldorei - startShaldorei) < 0 then
			barBalanceShaldorei = " |cFFFF2e2e["..(shaldorei - startShaldorei).."]"
		end
	end

	local barBalanceSilkweave = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (silkweave - startSilkweave) > 0 then
			barBalanceSilkweave = " |cFF69FF69["..(silkweave - startSilkweave).."]"
		elseif (silkweave - startSilkweave) < 0 then
			barBalanceSilkweave = " |cFFFF2e2e["..(silkweave - startSilkweave).."]"
		end
	end

	return shaldoreiText..barBalanceShaldorei.." "..silkweaveText..barBalanceSilkweave
end
-----------------------------------------------
local function GetTooltipText(self, id)

	local shaldoreiBag = "\r"..L["shaldorei"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124437)).."\r"
	local shaldoreiBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124437, true) - GetItemCount(124437))

	local silkweaveBag = L["silkweave"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(127004)).."\r"
	local silkweaveBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(127004, true) - GetItemCount(127004))

	local valueText = "" -- Difere com e sem reagente
	if shaldorei == 0 and silkweave == 0 then
		valueText = "\r"..L["info"].."\r|cFFFF2e2e"..L["noreagent"]
	else
		valueText = "\r"..L["info"]..shaldoreiBag..shaldoreiBank.."\r\r"..silkweaveBag..silkweaveBank
	end

	return valueText
end
-----------------------------------------------
local eventsTable = {
	PLAYER_ENTERING_WORLD = function(self)
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self.PLAYER_ENTERING_WORLD = nil

		startShaldorei = getShaldorei()
		shaldorei = startShaldorei

		startSilkweave = getSilkweave()
		silkweave = startSilkweave

		TitanPanelButton_UpdateButton(self.registry.id)

		self.BAG_UPDATE = function(self, bagID)
			local shald = getShaldorei()
			local silkw = getSilkweave()
			if shaldorei == shald and silkweave == silkw then return end

			shaldorei = shald
			silkweave = silkw
			TitanPanelButton_UpdateButton(self.registry.id)
		end
		self:RegisterEvent("BAG_UPDATE")
	end
}
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFEC7A37 "..L["tailoring"].."|r [|cFFEC7A37"..L["reagents"].."|r] Multi",
	tooltip = L["tailoring"].."|r [|cFFEC7A37"..L["reagents"].."|r]",
	icon = "Interface\\Icons\\Trade_tailoring",
	category = "Profession",
	version = version.."beta",
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareReagentsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	},
	eventsTable = eventsTable
})
